#!/usr/local/bin/python

import qio, sys, profile

def test(filespec):
    print "Using native readline"
    f = open(filespec)
    while 1:
        nl = f.readline()
        if nl == "": break
    f.close()
    del f


def testqio(filespec):
    print "Using QIO readline"
    f = qio.open(filespec)
    while 1:
        nl = f.readline()
        if nl == "": break
    f.close()
    del f


def testlines(filespec):
    print "Using native readlines"
    f = open(filespec)
    nl = f.readlines()
    #print len(nl)
    f.close()
    del f

def testqiolines(filespec):
    print "Using QIO readlines"
    f = qio.open(filespec)
    nl = f.readlines()
    #print len(nl)
    f.close()
    del f



filespec = '/news/insync/etc/history'

# one dry run to fill the buffers and try to make it fair...
f = open(filespec)
f.read()
f.close()

# compare readlines()
if 1:
    profile.run('testlines(filespec)')
    profile.run('testqiolines(filespec)')

# compare readline() loops
if 1:
    profile.run('test(filespec)')
    profile.run('testqio(filespec)')

# compare read() of a whole file
if 0:
    f = open(filespec)
    profile.run('z = f.read(); print len(z)')
    f.close()

    f = qio.open(filespec)
    profile.run('z = f.read(); print len(z)')
    f.close()
